<?php if (!defined('APPLICATION')) exit();

$PluginInfo['VanillaCategoryAutoSelect'] = array(
	'Name' => 'Category Auto Select',
	'Description' => 'Automatically select "Category" with new discussion (remake of Classic Vanilla extension). Trying to detect last viewed discussion or category by checking HTTP_REFERER variable (if you clicked "New Discussion" from menu (not panel button).',
	'Version' => '0.06',
	'RequiredApplications' => array('Vanilla' => '>=2'), 
	'Author' => 'Grandfather Frost'
);

class VanillaCategoryAutoSelectPlugin implements Gdn_IPlugin {
	
	public function PostController_Render_Before(&$PostController){

		$Referer = ArrayValue('HTTP_REFERER', $_SERVER);
		if(strtolower($PostController->RequestMethod) != 'discussion' || !$Referer) return;

		$SQL = Gdn::SQL();

		if(preg_match('/\/discussion\/(\d+)/i', $Referer, $Match)){
			$SQL
				->From('Discussion')
				->Where('DiscussionID', $Match[1]);
		}elseif(preg_match('/\/categories\/(.+)/i', $Referer, $Match)){
			$Name = urldecode($Match[1]);
			$SQL
				->From('Category')
				->Where('Name', $Name);
		}else return;

		$Data = $SQL
			->Select('CategoryID')
			->Get()
			->FirstRow();

		if($Data != False){
			//$PostController->CategoryID = $Data->CategoryID;
			$PostController->Form->SetData(array('CategoryID' => $Data->CategoryID));
		}
	}
	
	public function Setup(){
	}
}